package com.google.appengine.api.datastore;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.gwt.user.client.rpc.SerializationException;
import com.google.gwt.user.client.rpc.SerializationStreamReader;
import com.google.gwt.user.client.rpc.SerializationStreamWriter;

/**
 * @author Bryce Cottam 
 *
 */
public class Key_CustomFieldSerializer
{
	
	public static Key instantiate(SerializationStreamReader reader) throws SerializationException
	{
		String encoded = reader.readString();
		return KeyFactory.stringToKey(encoded);
	}
	
	public static void serialize(SerializationStreamWriter writer, Key instance) throws SerializationException
	{
		writer.writeString(KeyFactory.keyToString(instance));
		writer.writeString(instance.getAppId());
		writer.writeString(instance.getKind());
		writer.writeString(instance.getName());
		writer.writeLong(instance.getId());
	}
	
	public static void deserialize(SerializationStreamReader reader, Key instance) throws SerializationException
	{
		// nothing really to do here, since the instantiate method already did our work for us.
		instance.appId = reader.readString();
		instance.kind = reader.readString();
		instance.name = reader.readString();
		instance.id = reader.readLong();
	}
	
}
