package com.google.appengine.api.datastore;

import java.io.Serializable;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * @author Bryce Cottam 
 *
 */
public class Text implements Serializable, IsSerializable
{
	private Integer hash;
	private String value;
	
	public Text(String value)
	{
		this.value = value;
	}
	
	public String getValue()
	{
		return value;
	}
	
	public int hashCode()
	{
		if (hash == null)
		{
			hash = value == null ? super.hashCode() : value.hashCode();
		}
		
		return  hash;
	}
	
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		
		boolean eq = false;
		
		if (obj instanceof Text)
		{
			Text that = (Text) obj;
			String thisValue = this.getValue();
			String thatValue = that.getValue();
			
			if (thisValue != null && thatValue != null)
			{
				eq = thisValue.equals(thatValue);
			}
			else if (thisValue == null && thatValue == null)
			{
				eq = true;
			}
		}
		
		return eq;
	}
	
	public String toString()
	{
		return getValue();
	}

}
